/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	ScormLearnerCommentDataAccess
//	変更履歴
//		2004.02.01	新規作成
//      2006.12.01　変更 T.Kiyokawa
//                  終了時送信ログをXMLからテキスト形式に変更し、高速化
//

package jp.co.ntt.lms.lo.scorm;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import jp.co.ntt.lms.lo.LOException;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.Environment;
import jp.co.ntt.lms.xmo.util.DebugLog;

//　CommentOut Start 2006.11.24 T.Kiyokawa 学習ログCSV化のため
//import org.w3c.dom.Node;
// CommentOut End

/**
 * ScormLearnerCommentテーブルへのアクセス・クラス。
 * @author T.Nishiki
 */
public class ScormLearnerCommentDataAccess extends ScormDataAccess {
	/**
	 * テーブル名。
	 */
	public static final String TABLE_NAME = "Scorm_LearnerComment";

	/**
	 * テーブル・列名：ユーザID。
	 */
	public static final String USERID = "UserID";

	/**
	 * テーブル・列名：LOID。
	 */
	public static final String LOID = "LOID";

	/**
	 * テーブル・列名：学習セッション回数。
	 */
	public static final String STUDY_SESSION_COUNT = "StudySessionCount";

	/**
	 * テーブル・列名：アクティビティID。
	 */
	public static final String ACTIVITYID = "ActivityID";

	/**
	 * テーブル・列名：試行回数。
	 */
	public static final String ATTEMPT_COUNT = "AttemptCount";

	/**
	 * テーブル・列名：Learnセッション回数。
	 */
	public static final String LEARN_SESSION_COUNT = "LearnSessionCount";

	/**
	 * テーブル・列名：コメント数。
	 */
	public static final String LEARNERCOMMENTCOUNT = "LearnerCommentCount";

	/**
	 * テーブル・列名：セッションID。
	 */
	public static final String SESSIONID = "SessionID";

	/**
	 * テーブル・列名：コメント。
	 */
	public static final String LEARNER_COMMENT = "LearnerComment";

	/**
	 * テーブル・列名：ロケーション。
	 */
	public static final String LEARNER_COMMENT_LOCATION
			= "LearnerCommentLocation";

	/**
	 * テーブル・列名：時間。
	 */
	public static final String LEARNER_COMMENT_TIME = "LearnerCommentTime";

	/**
	 * &lt;コメント&gt;要素の値を取得するためのロケーション・パス。
	 */
	public static final String PATH_COMMENT_VALUE =
		"./comment/text()";

	/**
	 * &lt;ロケーション&gt;要素の値を取得するためのロケーション・パス。
	 */
	public static final String PATH_LOCATION_VALUE =
		"./location/text()";

	/**
	 * &lt;時間&gt;要素の値を取得するためのロケーション・パス。
	 */
	public static final String PATH_TIME_VALUE =
		"./datetime/text()";

	/**
	 * 文字列カラムの最大サイズ。
	 */
	public static final int COLUMN_SIZE_MAX;

	/**
	 * 文字列カラムの最大サイズ。
	 */
	public static final int COLUMN_SIZE_UNIT;
	
//	ADD start 2006.11.22 T.Kiyokawa
	/** 
	CSV・列番号：学習者コメント
	 */
	public static final int CSVCOL_LE_COMMENT = 4 ;


	/** 
	CSV・列番号：学習者コメントのSCO中の場所 
	 */
	public static final int CSVCOL_LE_LOCATION = 5 ;


	/** 
	CSV・列番号：学習者コメント記録日時
	 */
	public static final int CSVCOL_LE_DATETIME = 6 ;
	
//	ADD end 
	
	/**
	 * スタティック・イニシャライザ。
	 * データベースの種別に基づき、文字列カラムの最大サイズ定数を決定します。
	 */
	static {
		// データベースによってカラムサイズ・サイズ種別を設定
		int columnSizeMax = 0;
		int columnSizeUnit = 0;
		try {
			Environment environment = new Environment();
			String dbType = environment.getDBType();
			if (dbType.equals(Environment.DB_SQLSERVER)) {
				columnSizeMax = 4096;
				columnSizeUnit = ScormLoConstant.COLUMN_SIZE_UNIT_SQLSERVER;
			}
			else if (dbType.equals(Environment.DB_ORACLE)) {
				columnSizeMax = 4000;
				columnSizeUnit = ScormLoConstant.COLUMN_SIZE_UNIT_ORACLE;
			}
			else if (dbType.equals(Environment.DB_POSTGRE)) {
				columnSizeMax = 4096;
				columnSizeUnit = ScormLoConstant.COLUMN_SIZE_UNIT_POSTGRE;
			}
		}
		catch (Exception e) {
		}
		COLUMN_SIZE_MAX = columnSizeMax;
		COLUMN_SIZE_UNIT = columnSizeUnit;
	}

	/**
	 * コンストラクタ
	 **/
	public ScormLearnerCommentDataAccess() {
		super( TABLE_NAME );
	}

	// Add Start T.Kiyoakwa 2006.11.24

	/**
	 * ScormLearnerCommentテーブルへの書込みを実行します。<br>
	 * &lt;learnercomment&gt;要素ごとに呼び出され、レコードを追加します。<br>
	 *
	 * @param dataAccess データアクセスクラス。
	 * @param endLearnData 学習終了情報。
	 * @param learnerCommentCSV &lt;learnercomment&gt;CSVデータ。
	 * @param activityID データを書き込む対象が属しているアクティビティのID。
	 * @param attemptCount 試行回数。
	 *         学習ログ内で、データを書き込む対象が属している
	 *         &lt;attemptcount&gt;要素の位置（１以上の整数）。
	 * @param learnSessionCount Learnセッション回数。
	 *         学習ログ内で、データを書き込む対象が属している
	 *         &lt;learnsession&gt;要素の位置（１以上の整数）。
	 * @param learnerCommentCount 学習者コメント回数。
	 *         学習ログ内で、データを書き込む対象が属している
	 *         &lt;learnercomment&gt;要素の位置（１以上の整数）。
	 *
	 * @throws LOException データベースへの書込に失敗した場合。
	 */
	public static void insert(
		DataAccess dataAccess,
		ScormLoEndLearnData endLearnData,
		ScormLoCsvData learnerCommentCSV,
		String activityID,
		int attemptCount,
		int learnSessionCount,
		int learnerCommentCount)
		throws LOException {
		////////////////////////////////////////////////////////////////////////
		// メソッド開始ログ
		DebugLog.write(
			ScormLearnerCommentDataAccess.class,
			"HEAD insert("
				+ "dataAccess,endLearnData"
				+ "," + learnerCommentCSV + "," + activityID
				+ "," + attemptCount + "," + learnSessionCount
				+ "," + learnerCommentCount + ")",
			DebugLog.ROW);

		try {
			////////////////////////////////////////////////////////////////////
			// 各カラムの値を取得
			//==================================================================
			// カラムと値のマップ
			ScormColumnInfo[] columnInfos =
				makeColumnInfos(
					endLearnData, learnerCommentCSV,
					activityID,	attemptCount,
					learnSessionCount, learnerCommentCount);
			////////////////////////////////////////////////////////////////////
			// SQL文の生成
			String query =
				ScormLoUtil.makeInsertQuery(TABLE_NAME, columnInfos);
			////////////////////////////////////////////////////////////////////
			// SQL文の実行
			dataAccess.execute(query.toString());
		}
		catch (LOException e) {
			throw e;
		}
		catch (SQLException e) {
			DebugLog.write(
				ScormInteractionDataAccess.class, e, DebugLog.HIGHT);
			throw new LOException(e.getMessage());
		}
		////////////////////////////////////////////////////////////////////////
		// メソッド終了ログ
		DebugLog.write(
			ScormLearnerCommentDataAccess.class,
			"TAIL insert("
				+ "dataAccess,endLearnData"
				+ "," + learnerCommentCSV + "," + activityID
				+ "," + attemptCount + "," + learnSessionCount
				+ "," + learnerCommentCount + ")",
			DebugLog.ROW);
	}

	/**
	 * ScormLearnerCommentテーブルのカラム情報配列を生成します。<br>
	 * @param endLearnData 学習終了情報。
	 * @param learnerCommentCSV &lt;learnercomment&gt;CSVデータ。
	 * @param attemptCount 試行回数。
	 *         学習ログ内で、データを書き込む対象が属している
	 *         &lt;attemptcount&gt;要素の位置（１以上の整数）。
	 * @param activityID データを書き込む対象が属しているアクティビティのID。
	 * @param learnSessionCount Learnセッション回数。
	 *         学習ログ内で、データを書き込む対象が属している
	 *         &lt;learnsession&gt;要素の位置（１以上の整数）。
	 * @param learnerCommentCount 学習者コメント回数。
	 *         学習ログ内で、データを書き込む対象が属している
	 *         &lt;learnercomment&gt;要素の位置（１以上の整数）。
	 *
	 * @return ScormLearnerCommentテーブルのカラム情報配列。
	 * @throws LOException ノードからでデータ取得失敗した場合。
	 */
	private static ScormColumnInfo[] makeColumnInfos(
		ScormLoEndLearnData endLearnData,
		ScormLoCsvData learnerCommentCSV,
		String activityID,
		int attemptCount,
		int learnSessionCount,
		int learnerCommentCount)
		throws LOException {

		////////////////////////////////////////////////////////////////////////
		// メソッド開始ログ
		DebugLog.write(
			ScormLearnerCommentDataAccess.class,
			"HEAD makeColumnInfos(endLearnData"
				+ "," + learnerCommentCSV + "," + activityID
				+ "," + attemptCount + "," + learnSessionCount
				+ "," + learnerCommentCount + ")",
			DebugLog.ROW);

		// このメソッドの戻り値
		ScormColumnInfo[] columnInfos = null;
		// 配列生成用リスト
		List columnInfoList = new ArrayList();
		try {
			////////////////////////////////////////////////////////////////////
			// endLearnDataより取得できるデータをカラムとして設定
			//==================================================================
			// ユーザID
			String userID = endLearnData.getUserID();
			ScormColumnInfo userIDColumn = new ScormColumnInfo(
				USERID, userID,
				ScormColumnInfo.COLUMN_TYPE_STRING,
				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
			columnInfoList.add(userIDColumn);
			// LOID
			String loID = endLearnData.getLoID();
			ScormColumnInfo loIDColumn = new ScormColumnInfo(
				LOID, loID,
				ScormColumnInfo.COLUMN_TYPE_STRING,
				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
			columnInfoList.add(loIDColumn);
			// 学習セッション回数
			int studySessionCount = endLearnData.getStudySession();
			ScormColumnInfo studySessionCountColumn = new ScormColumnInfo(
				STUDY_SESSION_COUNT, Integer.toString(studySessionCount),
				ScormColumnInfo.COLUMN_TYPE_NUMBER,
				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
			columnInfoList.add(studySessionCountColumn);
			// セッションID
			int sessionID = endLearnData.getLoginSession();
			ScormColumnInfo sessionIDColumn = new ScormColumnInfo(
				SESSIONID, Integer.toString(sessionID),
				ScormColumnInfo.COLUMN_TYPE_STRING,
				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
			columnInfoList.add(sessionIDColumn);
			////////////////////////////////////////////////////////////////////
			// endLearnData、attemptNode以外より取得できるデータをカラムとして設定
			//==================================================================
			// アクティビティID
			ScormColumnInfo activityIDColumn = new ScormColumnInfo(
				ACTIVITYID, activityID,
				ScormColumnInfo.COLUMN_TYPE_STRING,
				ScormLoConstant.COLUMN_ACITIVITY_ID_SIZE_MAX,
				ScormLoConstant.COLUMN_ACITIVITY_ID_SIZE_UNIT);
			columnInfoList.add(activityIDColumn);
			// 試行回数
			ScormColumnInfo attemptCountColumn = new ScormColumnInfo(
				ATTEMPT_COUNT, Integer.toString(attemptCount),
				ScormColumnInfo.COLUMN_TYPE_NUMBER,
				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
			columnInfoList.add(attemptCountColumn);
			// Learnセッション回数
			ScormColumnInfo learnSessionCountColumn = new ScormColumnInfo(
				LEARN_SESSION_COUNT, Integer.toString(learnSessionCount),
				ScormColumnInfo.COLUMN_TYPE_NUMBER,
				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
			columnInfoList.add(learnSessionCountColumn);
			// コメント数
			ScormColumnInfo learnerCommentCountColumn = new ScormColumnInfo(
				LEARNERCOMMENTCOUNT, Integer.toString(learnerCommentCount),
				ScormColumnInfo.COLUMN_TYPE_NUMBER,
				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
			columnInfoList.add(learnerCommentCountColumn);
			////////////////////////////////////////////////////////////////////
			// attemptNodeより取得できるデータをカラムとして設定
			//==================================================================
			// コメント
			String learnerComment =
				learnerCommentCSV.getData(CSVCOL_LE_COMMENT);
			if (learnerComment != null) {
				ScormColumnInfo learnerCommentColumn = new ScormColumnInfo(
					LEARNER_COMMENT, learnerComment,
					ScormColumnInfo.COLUMN_TYPE_STRING,
					COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
				columnInfoList.add(learnerCommentColumn);
			}
			// ロケーション
			String learnerCommentLocation =
				learnerCommentCSV.getData(CSVCOL_LE_LOCATION);
			if (learnerCommentLocation != null) {
				ScormColumnInfo learnerCommentLocationColumn
					= new ScormColumnInfo(
						LEARNER_COMMENT_LOCATION, learnerCommentLocation,
						ScormColumnInfo.COLUMN_TYPE_STRING,
						COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
				columnInfoList.add(learnerCommentLocationColumn);
			}
			// コメント記録日時
			String commentTime =
				learnerCommentCSV.getData(CSVCOL_LE_DATETIME);
			if (commentTime != null) {
				// DB用のフォーマットに変換してから設定
				String commentTimeDBString = commentTime;
				ScormColumnInfo learnerCommentTimeColumn
					= new ScormColumnInfo(
						LEARNER_COMMENT_TIME, commentTimeDBString,
						ScormColumnInfo.COLUMN_TYPE_STRING,
						COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
				columnInfoList.add(learnerCommentTimeColumn);
			}
			////////////////////////////////////////////////////////////////////
			// リストを配列に変換
			columnInfos = new ScormColumnInfo[ columnInfoList.size() ];
			columnInfoList.toArray(columnInfos);
		}
		catch (LOException e) {
			throw e;
		}

		////////////////////////////////////////////////////////////////////////
		// メソッド終了ログ
		DebugLog.write(
			ScormLearnerCommentDataAccess.class,
			"TAIL makeColumnInfos(endLearnData"
				+ "," + learnerCommentCSV + "," + activityID
				+ "," + attemptCount + "," + learnSessionCount
				+ "," + learnerCommentCount + ")"
				+ " return " + columnInfos,
			DebugLog.ROW);
		return columnInfos;
	}
	// Add End

// CommentOut Start 2006.11.24 T.Kiyokawa 学習ログCSV化のため
//	/**
//	 * ScormLearnerCommentテーブルへの書込みを実行します。<br>
//	 * &lt;learnercomment&gt;要素ごとに呼び出され、レコードを追加します。<br>
//	 *
//	 * @param dataAccess データアクセスクラス。
//	 * @param endLearnData 学習終了情報。
//	 * @param learnerCommentNode &lt;learnercomment&gt;要素を表すノード。
//	 * @param activityID データを書き込む対象が属しているアクティビティのID。
//	 * @param attemptCount 試行回数。
//	 *         学習ログ内で、データを書き込む対象が属している
//	 *         &lt;attemptcount&gt;要素の位置（１以上の整数）。
//	 * @param learnSessionCount Learnセッション回数。
//	 *         学習ログ内で、データを書き込む対象が属している
//	 *         &lt;learnsession&gt;要素の位置（１以上の整数）。
//	 * @param learnerCommentCount 学習者コメント回数。
//	 *         学習ログ内で、データを書き込む対象が属している
//	 *         &lt;learnercomment&gt;要素の位置（１以上の整数）。
//	 *
//	 * @throws LOException データベースへの書込に失敗した場合。
//	 */
//	public static void insert(
//		DataAccess dataAccess,
//		ScormLoEndLearnData endLearnData,
//		Node learnerCommentNode,
//		String activityID,
//		int attemptCount,
//		int learnSessionCount,
//		int learnerCommentCount)
//		throws LOException {
//		////////////////////////////////////////////////////////////////////////
//		// メソッド開始ログ
//		DebugLog.write(
//			ScormLearnerCommentDataAccess.class,
//			"HEAD insert("
//				+ "dataAccess,endLearnData"
//				+ "," + learnerCommentNode + "," + activityID
//				+ "," + attemptCount + "," + learnSessionCount
//				+ "," + learnerCommentCount + ")",
//			DebugLog.ROW);
//
//		try {
//			////////////////////////////////////////////////////////////////////
//			// 各カラムの値を取得
//			//==================================================================
//			// カラムと値のマップ
//			ScormColumnInfo[] columnInfos =
//				makeColumnInfos(
//					endLearnData, learnerCommentNode,
//					activityID,	attemptCount,
//					learnSessionCount, learnerCommentCount);
//			////////////////////////////////////////////////////////////////////
//			// SQL文の生成
//			String query =
//				ScormLoUtil.makeInsertQuery(TABLE_NAME, columnInfos);
//			////////////////////////////////////////////////////////////////////
//			// SQL文の実行
//			dataAccess.execute(query.toString());
//		}
//		catch (LOException e) {
//			throw e;
//		}
//		catch (SQLException e) {
//			DebugLog.write(
//				ScormInteractionDataAccess.class, e, DebugLog.HIGHT);
//			throw new LOException(e.getMessage());
//		}
//		////////////////////////////////////////////////////////////////////////
//		// メソッド終了ログ
//		DebugLog.write(
//			ScormLearnerCommentDataAccess.class,
//			"TAIL insert("
//				+ "dataAccess,endLearnData"
//				+ "," + learnerCommentNode + "," + activityID
//				+ "," + attemptCount + "," + learnSessionCount
//				+ "," + learnerCommentCount + ")",
//			DebugLog.ROW);
//	}
//
//	/**
//	 * ScormLearnerCommentテーブルのカラム情報配列を生成します。<br>
//	 * @param endLearnData 学習終了情報。
//	 * @param learnerCommentNode &lt;learnercomment&gt;要素を表すノード。
//	 * @param attemptCount 試行回数。
//	 *         学習ログ内で、データを書き込む対象が属している
//	 *         &lt;attemptcount&gt;要素の位置（１以上の整数）。
//	 * @param activityID データを書き込む対象が属しているアクティビティのID。
//	 * @param learnSessionCount Learnセッション回数。
//	 *         学習ログ内で、データを書き込む対象が属している
//	 *         &lt;learnsession&gt;要素の位置（１以上の整数）。
//	 * @param learnerCommentCount 学習者コメント回数。
//	 *         学習ログ内で、データを書き込む対象が属している
//	 *         &lt;learnercomment&gt;要素の位置（１以上の整数）。
//	 *
//	 * @return ScormLearnerCommentテーブルのカラム情報配列。
//	 * @throws LOException ノードからでデータ取得失敗した場合。
//	 */
//	private static ScormColumnInfo[] makeColumnInfos(
//		ScormLoEndLearnData endLearnData,
//		Node learnerCommentNode,
//		String activityID,
//		int attemptCount,
//		int learnSessionCount,
//		int learnerCommentCount)
//		throws LOException {
//
//		////////////////////////////////////////////////////////////////////////
//		// メソッド開始ログ
//		DebugLog.write(
//			ScormLearnerCommentDataAccess.class,
//			"HEAD makeColumnInfos(endLearnData"
//				+ "," + learnerCommentNode + "," + activityID
//				+ "," + attemptCount + "," + learnSessionCount
//				+ "," + learnerCommentCount + ")",
//			DebugLog.ROW);
//
//		// このメソッドの戻り値
//		ScormColumnInfo[] columnInfos = null;
//		// 配列生成用リスト
//		List columnInfoList = new ArrayList();
//		try {
//			////////////////////////////////////////////////////////////////////
//			// endLearnDataより取得できるデータをカラムとして設定
//			//==================================================================
//			// ユーザID
//			String userID = endLearnData.getUserID();
//			ScormColumnInfo userIDColumn = new ScormColumnInfo(
//				USERID, userID,
//				ScormColumnInfo.COLUMN_TYPE_STRING,
//				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
//			columnInfoList.add(userIDColumn);
//			// LOID
//			String loID = endLearnData.getLoID();
//			ScormColumnInfo loIDColumn = new ScormColumnInfo(
//				LOID, loID,
//				ScormColumnInfo.COLUMN_TYPE_STRING,
//				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
//			columnInfoList.add(loIDColumn);
//			// 学習セッション回数
//			int studySessionCount = endLearnData.getStudySession();
//			ScormColumnInfo studySessionCountColumn = new ScormColumnInfo(
//				STUDY_SESSION_COUNT, Integer.toString(studySessionCount),
//				ScormColumnInfo.COLUMN_TYPE_NUMBER,
//				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
//			columnInfoList.add(studySessionCountColumn);
//			// セッションID
//			int sessionID = endLearnData.getLoginSession();
//			ScormColumnInfo sessionIDColumn = new ScormColumnInfo(
//				SESSIONID, Integer.toString(sessionID),
//				ScormColumnInfo.COLUMN_TYPE_STRING,
//				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
//			columnInfoList.add(sessionIDColumn);
//			////////////////////////////////////////////////////////////////////
//			// endLearnData、attemptNode以外より取得できるデータをカラムとして設定
//			//==================================================================
//			// アクティビティID
//			ScormColumnInfo activityIDColumn = new ScormColumnInfo(
//				ACTIVITYID, activityID,
//				ScormColumnInfo.COLUMN_TYPE_STRING,
//				ScormLoConstant.COLUMN_ACITIVITY_ID_SIZE_MAX,
//				ScormLoConstant.COLUMN_ACITIVITY_ID_SIZE_UNIT);
//			columnInfoList.add(activityIDColumn);
//			// 試行回数
//			ScormColumnInfo attemptCountColumn = new ScormColumnInfo(
//				ATTEMPT_COUNT, Integer.toString(attemptCount),
//				ScormColumnInfo.COLUMN_TYPE_NUMBER,
//				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
//			columnInfoList.add(attemptCountColumn);
//			// Learnセッション回数
//			ScormColumnInfo learnSessionCountColumn = new ScormColumnInfo(
//				LEARN_SESSION_COUNT, Integer.toString(learnSessionCount),
//				ScormColumnInfo.COLUMN_TYPE_NUMBER,
//				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
//			columnInfoList.add(learnSessionCountColumn);
//			// コメント数
//			ScormColumnInfo learnerCommentCountColumn = new ScormColumnInfo(
//				LEARNERCOMMENTCOUNT, Integer.toString(learnerCommentCount),
//				ScormColumnInfo.COLUMN_TYPE_NUMBER,
//				COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
//			columnInfoList.add(learnerCommentCountColumn);
//			////////////////////////////////////////////////////////////////////
//			// attemptNodeより取得できるデータをカラムとして設定
//			//==================================================================
//			// コメント
//			String learnerComment =
//				ScormLoUtil.getNodeValue(
//					learnerCommentNode, PATH_COMMENT_VALUE);
//			if (learnerComment != null) {
//				ScormColumnInfo learnerCommentColumn = new ScormColumnInfo(
//					LEARNER_COMMENT, learnerComment,
//					ScormColumnInfo.COLUMN_TYPE_STRING,
//					COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
//				columnInfoList.add(learnerCommentColumn);
//			}
//			// ロケーション
//			String learnerCommentLocation =
//				ScormLoUtil.getNodeValue(
//					learnerCommentNode, PATH_LOCATION_VALUE);
//			if (learnerCommentLocation != null) {
//				ScormColumnInfo learnerCommentLocationColumn
//					= new ScormColumnInfo(
//						LEARNER_COMMENT_LOCATION, learnerCommentLocation,
//						ScormColumnInfo.COLUMN_TYPE_STRING,
//						COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
//				columnInfoList.add(learnerCommentLocationColumn);
//			}
//			// コメント記録日時
//			String commentTime =
//				ScormLoUtil.getNodeValue(
//					learnerCommentNode, PATH_TIME_VALUE);
//			if (commentTime != null) {
//				// DB用のフォーマットに変換してから設定
//				String commentTimeDBString = commentTime;
//				ScormColumnInfo learnerCommentTimeColumn
//					= new ScormColumnInfo(
//						LEARNER_COMMENT_TIME, commentTimeDBString,
//						ScormColumnInfo.COLUMN_TYPE_STRING,
//						COLUMN_SIZE_MAX, COLUMN_SIZE_UNIT);
//				columnInfoList.add(learnerCommentTimeColumn);
//			}
//			////////////////////////////////////////////////////////////////////
//			// リストを配列に変換
//			columnInfos = new ScormColumnInfo[ columnInfoList.size() ];
//			columnInfoList.toArray(columnInfos);
//		}
//		catch (LOException e) {
//			throw e;
//		}
//
//		////////////////////////////////////////////////////////////////////////
//		// メソッド終了ログ
//		DebugLog.write(
//			ScormLearnerCommentDataAccess.class,
//			"TAIL makeColumnInfos(endLearnData"
//				+ "," + learnerCommentNode + "," + activityID
//				+ "," + attemptCount + "," + learnSessionCount
//				+ "," + learnerCommentCount + ")"
//				+ " return " + columnInfos,
//			DebugLog.ROW);
//		return columnInfos;
//	}
	// CommentOut End
	
	/**
	 * 指定されたユーザ、教材の組み合わせのログを削除します。
	 * @param dataAccess データアクセス・オブジェクト。
	 * @param userID 削除対象のユーザID。
	 * @param loID 削除対象の教材のLOID。
	 * @throws LOException データベースアクセス中に例外が発生した場合。
	 */
	public static void delete(
		DataAccess dataAccess, String userID, String loID)
		throws LOException {

		// メソッド開始ログ
		DebugLog.write(
			ScormLearnerCommentDataAccess.class,
			"HEAD delete(" + dataAccess + "," + userID + "," + loID + ")",
			DebugLog.ROW);
		try {
			// WHERE句の生成
			StringBuffer queryWhere = new StringBuffer();
			if (loID != null) {
				queryWhere.append(" and " + LOID + "='" + loID + "'" );
			}
			if (userID != null) {
				queryWhere.append(" and " + USERID + "='" + userID + "'" );
			}
			// 削除クエリの生成
			StringBuffer query = new StringBuffer();
			query.append("delete from " + TABLE_NAME );
			if (queryWhere.length() > 0) {
				query.append(" where " + queryWhere.substring(5) );
			}
			// 削除クエリの実行
			String queryString = query.toString();
			DebugLog.write( ScormAttemptDataAccess.class,
				queryString, DebugLog.MID);
			dataAccess.execute(queryString);
		}
		catch (SQLException e) {
			DebugLog.write(ScormAttemptDataAccess.class,
				e, DebugLog.HIGHT);
		}
		// メソッド終了ログ
		DebugLog.write(
			ScormLearnerCommentDataAccess.class,
			"TAIL delete(" + dataAccess + "," + userID + "," + loID + ")",
			DebugLog.ROW);
	}

	/**
	 * Learnセッション回数最大値を取得します。<br>
	 * 指定したユーザID、LOID、学習回数の組み合わせで、
	 * アクティビティ別に最大試行回数の最大Learnセッション回数を
	 * 文字列の２次元配列として戻します。
	 * 該当するレコードが存在しない場合、要素数０の配列を戻します。
	 * <br>
	 * @param dataAccess データアクセスオブジェクト。
	 * @param userID ユーザID。
	 * @param loID LOID。
	 * @param studySession 学習回数（開始−終了で１単位の回数）
	 * @return 以下の１次元文字列配列を要素とする配列を戻します。
	 * <table border="1">
	 * 	<tr>
	 * 		<th>インデックス</th>
	 * 		<th>値</th>
	 * 	</tr>
	 * 	<tr>
	 * 		<td align="right">0</td>
	 * 		<td>アクティビティID</td>
	 * 	</tr>
	 * 	<tr>
	 * 		<td align="right">1</td>
	 * 		<td>同じアクティビティの中で最大の試行回数</td>
	 * 	</tr>
	 * 	<tr>
	 * 		<td align="right">2</td>
	 * 		<td>
	 * 			同じアクティビティの中で最大の試行回数の中の
	 * 			最大のLearnセッション回数
	 * 		</td>
	 * 	</tr>
	 * </table>
	 * <br>
	 * @throws LOException 処理（データベースアクセス）中にエラーが発生した場合。
	 */
	public static String[][] getMaxLearnSessionCount(
			DataAccess dataAccess, String userID,
			String loID, int studySession)
			throws LOException {

		// メソッド開始ログ
		DebugLog.write(
			ScormAttemptDataAccess.class,
			"HEAD getMaxLearnSessionCount("
				+ dataAccess + "," + userID
				+ "," + loID + "," + studySession + ")",
			DebugLog.ROW);

		// このメソッドの戻り値
		String[][] matrix = null;
		// クエリ結果セット
		ResultSet resultSet = null;
		// tryブロック内に例外が発生していないか示すフラグ（true＝例外なし）
		boolean successFlag = false;
		try {
			////////////////////////////////////////////////////////////////////
			// クエリ文の生成
			StringBuffer query = new StringBuffer();
			query.append("select");
			// アクティビティID
			query.append(" a." + ACTIVITYID + " as " + ACTIVITYID);
			// 最大試行回数
			query.append(",a." + ATTEMPT_COUNT + " as " + ATTEMPT_COUNT);
			// その中の最大Learnセッション回数
			query.append(",max(a." + LEARN_SESSION_COUNT + ")"
							+ " as " + LEARN_SESSION_COUNT);
			query.append(" from " + TABLE_NAME + " a");
			query.append(" inner join (");
			// =================================================================
			// 最大試行回数を取得するためのサブクエリ
			query.append(	"select");
			query.append(	" " + USERID + " as " + USERID);
			query.append(	"," + LOID + " as " + LOID);
			query.append(	"," + STUDY_SESSION_COUNT);
			query.append(			" as " + STUDY_SESSION_COUNT);
			query.append(	"," + ACTIVITYID + " as " + ACTIVITYID);
			query.append(	",max(" + ATTEMPT_COUNT + ") as " + ATTEMPT_COUNT);
			query.append(	" from " + TABLE_NAME);
			// サブクエリでの条件
			// 指定されたユーザID、LOID、学習回数と一致するレコード
			query.append(	" where " + USERID + "='" + userID + "'");
			query.append(	" and " + LOID + "='" + loID + "'");
			query.append(	" and " + STUDY_SESSION_COUNT );
			query.append(		"=" + studySession );
			// サブクエリでmax(AttemptCount)を使用するためのgroup by句
			query.append(	" group by ");
			query.append(	" " + USERID);
			query.append(	"," + LOID);
			query.append(	"," + STUDY_SESSION_COUNT);
			query.append(	"," + ACTIVITYID);
			query.append(") b");
			// =================================================================
			// サブクエリとの結合条件
			// ユーザID、LOID、学習回数、アクティビティIDが一致して、
			// 試行回数が最大値のレコード
			query.append(" on a." + USERID + "=b." + USERID );
			query.append(" and a." + LOID + "=b." + LOID );
			query.append(" and a." + STUDY_SESSION_COUNT );
			query.append(		"=b." + STUDY_SESSION_COUNT );
			query.append(" and a." + ACTIVITYID + "=b." + ACTIVITYID );
			query.append(" and a." + ATTEMPT_COUNT + "=b." + ATTEMPT_COUNT );
			// =================================================================
			// where句
			// 指定されたユーザID、LOID、学習回数と一致するレコード
			query.append(" where a." + USERID + "='" + userID + "'");
			query.append(" and a." + LOID + "='" + loID + "'");
			query.append(" and a." + STUDY_SESSION_COUNT );
			query.append(		"=" + studySession );
			// =================================================================
			// max(LearnSessionCount)を使用するためのgroup by句
			query.append(" group by");
			query.append(" a." + ACTIVITYID);
			query.append(",a." + ATTEMPT_COUNT);
			////////////////////////////////////////////////////////////////////
			// クエリ発行
			String queryString = query.toString();
			DebugLog.write( ScormAttemptDataAccess.class,
				queryString, DebugLog.MID);
			resultSet = dataAccess.executeQuery(queryString);
			////////////////////////////////////////////////////////////////////
			// クエリ結果のリスト化
			List list = new ArrayList();
			while (resultSet.next()) {
				String[] record = new String[3];
				record[0] = resultSet.getString(ACTIVITYID).trim();
				record[1] = resultSet.getString(ATTEMPT_COUNT);
				record[2] = resultSet.getString(LEARN_SESSION_COUNT);

				list.add(record);
			}
			//リストを配列化
			matrix = new String[list.size()][];
			list.toArray(matrix);

			// tryブロック最後まで到達したのでフラグをtrueに変更
			successFlag = true;
		}
		catch (SQLException e) {
			DebugLog.write(ScormAttemptDataAccess.class,
				e, DebugLog.HIGHT);
			throw new LOException(e.getMessage());
		}
		finally {
			// 結果セットのクローズ
			if (resultSet != null) {
				try {
					resultSet.close();
				}
				catch (SQLException e) {
					DebugLog.write(ScormAttemptDataAccess.class,
						e, DebugLog.HIGHT);
					// tryブロックにて例外が発生しなければ、スロー
					if (successFlag) {
						throw new LOException(e.getMessage());
					}
				}
			}
		}
		// メソッド終了ログ
		DebugLog.write(
			ScormAttemptDataAccess.class,
			"TAIL getMaxLearnSessionCount("
				+ dataAccess + "," + userID
				+ "," + loID + "," + studySession + ")",
			DebugLog.ROW);
		return matrix;
	}
}
